#!/bin/sh
# This file automatically generated by build system

MODE=normal
APP=diggen

for i; do
    case "$i" in
	--gdb)
	    MODE=gdb
	    shift
	    ;;
	--valgrind)
	    MODE=valgrind
	    shift
	    ;;
        --help)
            cat >&2 <<EOF
Usage: run.sh [options..] [target] [target-options..]

Run the given target.

Targets:
  diggen [default]: Digital Generation executable
EOF
            exit 1;
            ;;
        diggen) APP=diggen ; shift ;;
	*)
	    break
	    ;;
    esac
done

check_app()
{
    if test ! -x "$1" ; then
        echo "error: $1 does not exist, did you run make?" >&2
        exit 1
    fi
}

case $APP:$MODE in
    diggen:normal)
        check_app ./build/product/Digital_Generation
        exec ./build/product/Digital_Generation -dlog.level.root=debug -dlog.winconsole=yes -dpath.data=data "$@"
        ;;
    diggen:gdb)
        check_app ./build/product/Digital_Generation
        exec gdb --args ./build/product/Digital_Generation -dlog.level.root=debug -dlog.winconsole=yes -dpath.data=data "$@"
        ;;
    diggen:valgrind)
        check_app ./build/product/Digital_Generation
        exec valgrind -- ./build/product/Digital_Generation -dlog.level.root=debug -dlog.winconsole=yes -dpath.data=data "$@"
        ;;
esac
